"use strict";
var UserFactory_1 = require("web-angularjs-user-factory/UserFactory");
var factory_1 = require("../list/factory");
var BasicItemService = (function () {
    function BasicItemService(userFactory, listFactory, dataBaseUrl) {
        this.userFactory = userFactory;
        this.listFactory = listFactory;
        this.dataBaseUrl = dataBaseUrl;
        this.mode = 'router';
    }
    BasicItemService.prototype.getMode = function (controller) {
        if (controller.id !== undefined) {
            return this.mode = 'event';
        }
        else {
            return this.mode = 'router';
        }
    };
    BasicItemService.prototype.$get = function () {
        return this;
    };
    BasicItemService.prototype.getItem = function (id, cb, failCB) {
        if (id === undefined || id.indexOf('placeholder') !== -1) {
            return cb({});
        }
        this.userFactory.httpServerCall(this.dataBaseUrl + '/' + id, 'get', undefined, function (data) {
            if (data && data.data && (data.data.length || !data.data.error)) {
                cb && cb(data.data);
            }
            else {
                failCB && failCB(data.data);
            }
        });
    };
    ;
    BasicItemService.prototype.saveItem = function (item, cb, failCB) {
        var _this = this;
        if (failCB === void 0) { failCB = undefined; }
        this.userFactory.httpServerCall(this.dataBaseUrl, 'PUT', item, function (response) {
            if (response.data.error)
                return failCB && failCB(response.data);
            _this.listFactory.AddedItem();
            item = response.data[0];
            cb && cb(item);
        }, function () {
            failCB && failCB(undefined);
        });
    };
    ;
    BasicItemService.prototype.deleteItem = function (item, cb, failCB) {
        var _this = this;
        if (failCB === void 0) { failCB = undefined; }
        if (!item || !item._id)
            return failCB && failCB(undefined);
        this.userFactory.httpServerCall(this.dataBaseUrl + '/' + item._id, 'DELETE', item, function (response) {
            if (response.data.error)
                return failCB && failCB(response.data);
            _this.listFactory.AddedItem();
            item = undefined;
            cb && cb();
        }, function () {
            failCB && failCB(undefined);
        });
    };
    ;
    BasicItemService.prototype.createItem = function (item, cb, failCB) {
        var _this = this;
        if (failCB === void 0) { failCB = undefined; }
        this.userFactory.httpServerCall(this.dataBaseUrl, 'POST', item, function (response) {
            if (response.data.error)
                return failCB && failCB(response.data);
            _this.listFactory.AddedItem();
            if (response.data.length)
                item = response.data[0];
            else
                item = response.data;
            cb && cb(item);
        }, function (error) {
            failCB && failCB(error);
        });
    };
    ;
    BasicItemService.BasicItemService = function () {
        return [UserFactory_1.UserFactory.factoryName,
            factory_1.BasicListFactory.factoryName, function (uf, blf) {
                return new BasicItemService(uf, blf, '/api/item');
            }];
    };
    BasicItemService.prototype.getId = function (controller, $stateParams) {
        if (this.mode === 'router') {
            return $stateParams.id;
        }
        else {
            return controller.id;
        }
    };
    return BasicItemService;
}());
BasicItemService.serviceName = 'basicItemItemService';
BasicItemService.$inject = [
    UserFactory_1.UserFactory.factoryName,
    factory_1.BasicListFactory.factoryName
];
exports.BasicItemService = BasicItemService;
BasicItemService.$inject.push(BasicItemService);
//# sourceMappingURL=service.js.map